import time


class Logger:
    def __init__(self, v=True, o=None):
        self.verbose = v
        self.outfile = o

    def information(self, s):
        self.__write('[INFO]: ' + s, "")

    def warning(self, s):
        self.__write('[WARN]: ' + s, "\033[1;33m")

    def error(self, s):
        self.__write('[ERROR]: ' + s, "\033[1;31m", True)

    def output(self, s):
        self.__write(s, "\033[1;32m", True)

    def __write(self, s, f, v=False):
        if self.outfile is not None:
            with open(self.outfile, "a") as out:
                out.write(time.strftime("%Y-%m-%d_%H%M%S") + " " + s + "\r\n")
        if self.verbose or v:
            print(f + s + "\033[1;0m")
